#ifndef _LINUX_IPT_IFWLOG_H
#define _LINUX_IPT_IFWLOG_H

#ifndef NETLINK_IFWLOG
#define NETLINK_IFWLOG  20
#endif

#ifndef __KERNEL__
/* Multicast groups - backwards compatiblility for userspace */
#define IFWLOG_NLGRP_NONE 0x00000000
#define IFWLOG_NLGRP_DEF  0x00000001 /* default message group */
#endif

enum {
	IFWLOG_NLGRP_NONE,
#define IFWLOG_NLGRP_NONE IFWLOG_NLGRP_NONE
	IFWLOG_NLGRP_DEF,
#define IFWLOG_NLGRP_DEF IFWLOG_NLGRP_DEF
	__IFWLOG_NLGRP_MAX
};
#define IFWLOG_NLGRP_MAX (__IFWLOG_NLGRP_MAX - 1)

#define PREFSIZ         32

struct nl_msg {				/* Netlink message */
	long timestamp_sec;             /* time packet */
	char indev_name[IFNAMSIZ];      /* name of the ingoing interface */
	char outdev_name[IFNAMSIZ];     /* name of the outgoing interface */
	unsigned char prefix[PREFSIZ];  /* informations on the logging reason */
	struct iphdr ip;
	union {
		struct tcphdr th;
		struct udphdr uh;
	} h;
};

struct ipt_IFWLOG_info {
	char prefix[PREFSIZ];
};

#endif /* _LINUX_IPT_IFWLOG_H */
